# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Classroom.V1.Model.AssignmentSubmission do
  @moduledoc """
  Student work for an assignment.

  ## Attributes

  *   `attachments` (*type:* `list(GoogleApi.Classroom.V1.Model.Attachment.t)`, *default:* `nil`) - Attachments added by the student. Drive files that correspond to materials with a share mode of STUDENT_COPY may not exist yet if the student has not accessed the assignment in Classroom. Some attachment metadata is only populated if the requesting user has permission to access it. Identifier and alternate_link fields are always available, but others (for example, title) may not be.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :attachments => list(GoogleApi.Classroom.V1.Model.Attachment.t()) | nil
        }

  field(:attachments, as: GoogleApi.Classroom.V1.Model.Attachment, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Classroom.V1.Model.AssignmentSubmission do
  def decode(value, options) do
    GoogleApi.Classroom.V1.Model.AssignmentSubmission.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Classroom.V1.Model.AssignmentSubmission do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
