# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Classroom.V1.Model.CourseMaterial do
  @moduledoc """
  A material attached to a course as part of a material set.

  ## Attributes

  *   `driveFile` (*type:* `GoogleApi.Classroom.V1.Model.DriveFile.t`, *default:* `nil`) - Google Drive file attachment.
  *   `form` (*type:* `GoogleApi.Classroom.V1.Model.Form.t`, *default:* `nil`) - Google Forms attachment.
  *   `link` (*type:* `GoogleApi.Classroom.V1.Model.Link.t`, *default:* `nil`) - Link atatchment.
  *   `youTubeVideo` (*type:* `GoogleApi.Classroom.V1.Model.YouTubeVideo.t`, *default:* `nil`) - Youtube video attachment.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :driveFile => GoogleApi.Classroom.V1.Model.DriveFile.t() | nil,
          :form => GoogleApi.Classroom.V1.Model.Form.t() | nil,
          :link => GoogleApi.Classroom.V1.Model.Link.t() | nil,
          :youTubeVideo => GoogleApi.Classroom.V1.Model.YouTubeVideo.t() | nil
        }

  field(:driveFile, as: GoogleApi.Classroom.V1.Model.DriveFile)
  field(:form, as: GoogleApi.Classroom.V1.Model.Form)
  field(:link, as: GoogleApi.Classroom.V1.Model.Link)
  field(:youTubeVideo, as: GoogleApi.Classroom.V1.Model.YouTubeVideo)
end

defimpl Poison.Decoder, for: GoogleApi.Classroom.V1.Model.CourseMaterial do
  def decode(value, options) do
    GoogleApi.Classroom.V1.Model.CourseMaterial.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Classroom.V1.Model.CourseMaterial do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
