# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Classroom.V1.Model.CourseMaterialSet do
  @moduledoc """
  A set of materials that appears on the "About" page of the course. These materials might include a syllabus, schedule, or other background information relating to the course as a whole.

  ## Attributes

  *   `materials` (*type:* `list(GoogleApi.Classroom.V1.Model.CourseMaterial.t)`, *default:* `nil`) - Materials attached to this set.
  *   `title` (*type:* `String.t`, *default:* `nil`) - Title for this set.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :materials => list(GoogleApi.Classroom.V1.Model.CourseMaterial.t()) | nil,
          :title => String.t() | nil
        }

  field(:materials, as: GoogleApi.Classroom.V1.Model.CourseMaterial, type: :list)
  field(:title)
end

defimpl Poison.Decoder, for: GoogleApi.Classroom.V1.Model.CourseMaterialSet do
  def decode(value, options) do
    GoogleApi.Classroom.V1.Model.CourseMaterialSet.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Classroom.V1.Model.CourseMaterialSet do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
