# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Classroom.V1.Model.GuardianInvitation do
  @moduledoc """
  An invitation to become the guardian of a specified user, sent to a specified email address.

  ## Attributes

  *   `creationTime` (*type:* `DateTime.t`, *default:* `nil`) - The time that this invitation was created. Read-only.
  *   `invitationId` (*type:* `String.t`, *default:* `nil`) - Unique identifier for this invitation. Read-only.
  *   `invitedEmailAddress` (*type:* `String.t`, *default:* `nil`) - Email address that the invitation was sent to. This field is only visible to domain administrators.
  *   `state` (*type:* `String.t`, *default:* `nil`) - The state that this invitation is in.
  *   `studentId` (*type:* `String.t`, *default:* `nil`) - ID of the student (in standard format)
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :creationTime => DateTime.t() | nil,
          :invitationId => String.t() | nil,
          :invitedEmailAddress => String.t() | nil,
          :state => String.t() | nil,
          :studentId => String.t() | nil
        }

  field(:creationTime, as: DateTime)
  field(:invitationId)
  field(:invitedEmailAddress)
  field(:state)
  field(:studentId)
end

defimpl Poison.Decoder, for: GoogleApi.Classroom.V1.Model.GuardianInvitation do
  def decode(value, options) do
    GoogleApi.Classroom.V1.Model.GuardianInvitation.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Classroom.V1.Model.GuardianInvitation do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
