# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Classroom.V1.Model.Invitation do
  @moduledoc """
  An invitation to join a course.

  ## Attributes

  *   `courseId` (*type:* `String.t`, *default:* `nil`) - Identifier of the course to invite the user to.
  *   `id` (*type:* `String.t`, *default:* `nil`) - Identifier assigned by Classroom. Read-only.
  *   `role` (*type:* `String.t`, *default:* `nil`) - Role to invite the user to have. Must not be `COURSE_ROLE_UNSPECIFIED`.
  *   `userId` (*type:* `String.t`, *default:* `nil`) - Identifier of the invited user. When specified as a parameter of a request, this identifier can be set to one of the following: * the numeric identifier for the user * the email address of the user * the string literal `"me"`, indicating the requesting user
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :courseId => String.t() | nil,
          :id => String.t() | nil,
          :role => String.t() | nil,
          :userId => String.t() | nil
        }

  field(:courseId)
  field(:id)
  field(:role)
  field(:userId)
end

defimpl Poison.Decoder, for: GoogleApi.Classroom.V1.Model.Invitation do
  def decode(value, options) do
    GoogleApi.Classroom.V1.Model.Invitation.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Classroom.V1.Model.Invitation do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
