# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Classroom.V1.Model.Link do
  @moduledoc """
  URL item.

  ## Attributes

  *   `thumbnailUrl` (*type:* `String.t`, *default:* `nil`) - URL of a thumbnail image of the target URL. Read-only.
  *   `title` (*type:* `String.t`, *default:* `nil`) - Title of the target of the URL. Read-only.
  *   `url` (*type:* `String.t`, *default:* `nil`) - URL to link to. This must be a valid UTF-8 string containing between 1 and 2024 characters.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :thumbnailUrl => String.t() | nil,
          :title => String.t() | nil,
          :url => String.t() | nil
        }

  field(:thumbnailUrl)
  field(:title)
  field(:url)
end

defimpl Poison.Decoder, for: GoogleApi.Classroom.V1.Model.Link do
  def decode(value, options) do
    GoogleApi.Classroom.V1.Model.Link.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Classroom.V1.Model.Link do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
