# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Classroom.V1.Model.ListCourseWorkMaterialResponse do
  @moduledoc """
  Response when listing course work material.

  ## Attributes

  *   `courseWorkMaterial` (*type:* `list(GoogleApi.Classroom.V1.Model.CourseWorkMaterial.t)`, *default:* `nil`) - Course work material items that match the request.
  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token identifying the next page of results to return. If empty, no further results are available.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :courseWorkMaterial => list(GoogleApi.Classroom.V1.Model.CourseWorkMaterial.t()) | nil,
          :nextPageToken => String.t() | nil
        }

  field(:courseWorkMaterial, as: GoogleApi.Classroom.V1.Model.CourseWorkMaterial, type: :list)
  field(:nextPageToken)
end

defimpl Poison.Decoder, for: GoogleApi.Classroom.V1.Model.ListCourseWorkMaterialResponse do
  def decode(value, options) do
    GoogleApi.Classroom.V1.Model.ListCourseWorkMaterialResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Classroom.V1.Model.ListCourseWorkMaterialResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
