# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Classroom.V1.Model.ModifyIndividualStudentsOptions do
  @moduledoc """
  Contains fields to add or remove students from a course work or announcement where the `assigneeMode` is set to `INDIVIDUAL_STUDENTS`.

  ## Attributes

  *   `addStudentIds` (*type:* `list(String.t)`, *default:* `nil`) - IDs of students to be added as having access to this coursework/announcement.
  *   `removeStudentIds` (*type:* `list(String.t)`, *default:* `nil`) - IDs of students to be removed from having access to this coursework/announcement.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :addStudentIds => list(String.t()) | nil,
          :removeStudentIds => list(String.t()) | nil
        }

  field(:addStudentIds, type: :list)
  field(:removeStudentIds, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Classroom.V1.Model.ModifyIndividualStudentsOptions do
  def decode(value, options) do
    GoogleApi.Classroom.V1.Model.ModifyIndividualStudentsOptions.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Classroom.V1.Model.ModifyIndividualStudentsOptions do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
