# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Classroom.V1.Model.StateHistory do
  @moduledoc """
  The history of each state this submission has been in.

  ## Attributes

  *   `actorUserId` (*type:* `String.t`, *default:* `nil`) - The teacher or student who made the change.
  *   `state` (*type:* `String.t`, *default:* `nil`) - The workflow pipeline stage.
  *   `stateTimestamp` (*type:* `DateTime.t`, *default:* `nil`) - When the submission entered this state.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :actorUserId => String.t() | nil,
          :state => String.t() | nil,
          :stateTimestamp => DateTime.t() | nil
        }

  field(:actorUserId)
  field(:state)
  field(:stateTimestamp, as: DateTime)
end

defimpl Poison.Decoder, for: GoogleApi.Classroom.V1.Model.StateHistory do
  def decode(value, options) do
    GoogleApi.Classroom.V1.Model.StateHistory.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Classroom.V1.Model.StateHistory do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
