# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Classroom.V1.Model.SubmissionHistory do
  @moduledoc """
  The history of the submission. This currently includes state and grade histories.

  ## Attributes

  *   `gradeHistory` (*type:* `GoogleApi.Classroom.V1.Model.GradeHistory.t`, *default:* `nil`) - The grade history information of the submission, if present.
  *   `stateHistory` (*type:* `GoogleApi.Classroom.V1.Model.StateHistory.t`, *default:* `nil`) - The state history information of the submission, if present.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :gradeHistory => GoogleApi.Classroom.V1.Model.GradeHistory.t() | nil,
          :stateHistory => GoogleApi.Classroom.V1.Model.StateHistory.t() | nil
        }

  field(:gradeHistory, as: GoogleApi.Classroom.V1.Model.GradeHistory)
  field(:stateHistory, as: GoogleApi.Classroom.V1.Model.StateHistory)
end

defimpl Poison.Decoder, for: GoogleApi.Classroom.V1.Model.SubmissionHistory do
  def decode(value, options) do
    GoogleApi.Classroom.V1.Model.SubmissionHistory.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Classroom.V1.Model.SubmissionHistory do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
