# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Classroom.V1.Model.YouTubeVideo do
  @moduledoc """
  YouTube video item.

  ## Attributes

  *   `alternateLink` (*type:* `String.t`, *default:* `nil`) - URL that can be used to view the YouTube video. Read-only.
  *   `id` (*type:* `String.t`, *default:* `nil`) - YouTube API resource ID.
  *   `thumbnailUrl` (*type:* `String.t`, *default:* `nil`) - URL of a thumbnail image of the YouTube video. Read-only.
  *   `title` (*type:* `String.t`, *default:* `nil`) - Title of the YouTube video. Read-only.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :alternateLink => String.t() | nil,
          :id => String.t() | nil,
          :thumbnailUrl => String.t() | nil,
          :title => String.t() | nil
        }

  field(:alternateLink)
  field(:id)
  field(:thumbnailUrl)
  field(:title)
end

defimpl Poison.Decoder, for: GoogleApi.Classroom.V1.Model.YouTubeVideo do
  def decode(value, options) do
    GoogleApi.Classroom.V1.Model.YouTubeVideo.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Classroom.V1.Model.YouTubeVideo do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
